package mole.entities.controlers 
{
	import mole.entities.CPlayer;
	
	/**
	 * Représente le cerveau d'une entité.
	 * Il permet d'avoir une entité de base commune pour le joueur et les NPC.
	 * @author Cédric Liaudet
	 */
	public interface IControler 
	{
		/**
		 * Callback de mise à jours du controlleur.
		 */
		function update(_Player:CPlayer):void;
		
		/**
		 * Renvoie la vitesse du controlleur.
		 * @return La vitesse du controlleur.
		 */
		function GetSpeed():int;
	}

}