package mole.state 
{
	import mole.Main;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	/**
	 * L'état de pause.
	 * @author Cédric Liaudet
	 */
	public class CPause extends Entity implements IState
	{
		//[Embed(source = '../../data/images/pause.png')]
		//private const PAUSE:Class;
		
		/**
		 * Constructeur par défaut.
		 */
		public function CPause() 
		{
			
		}
		
		/**
		 * Chargement des données.
		 */
		public function OnStart():void
		{
			// Chargement du visuel.
			//graphic = new Image(PAUSE);
			Main.World.add(this);
						
			// On replace l'image.
			x = FP.camera.x;
			y = FP.camera.y;
		}
		
		/**
		 * Mise à jours de l'état.
		 */
		public function OnUpdate(): void
		{
			if (Input.pressed("pause"))
			{
				Main.GameStateManager.RemoveCurrentState();
			}
		}
		
		/**
		 * "Destruction" des données.
		 */
		public function OnEnd():void
		{
			Main.World.remove(this);
		}
		
		/**
		 * Mise en pause
		 */
		public function OnPause():void
		{
			
		}
		
		/**
		 * Retour de pause
		 */
		public function OnResume():void
		{
			
		}
	}

}